; =========================================================================
   TITLE LOADERGEN.ASM: Example of a loader that patch a remote process

; 			by  n u M I T_o r
; 		    numit_or@subdimension.com
; 	    http://members.nbci.com/numit_or/asm.html
; =========================================================================

	.386
	.model flat, stdcall

; =========================================================================

include windows.inc
include kernel32.inc
include user32.inc

includelib kernel32.lib
includelib user32.lib

; =========================================================================

	.code
start:
; ------------------------------ 
;Get the adress of LoadLibraryA 
; ------------------------------
	; --------------------------------
	; Get the address of kernel32.dll
	; -------------------------------
	lea  eax, @kernel32
	push eax
	call GetModuleHandle
	or   eax, eax
	je   @70
	mov  @krn32, eax
	push eax
	; -------------------------------
	; Get the address of LoadLibrary 
	; -------------------------------
	mov  esi, GetProcAddress
	lea  ecx, @LoadLibrary
	push ecx
	push eax
	call esi
	or   eax, eax
	jne  _a

	pop  eax
	push 30h
	push offset capt
	push offset msg1
	push 0
	call MessageBox
	jmp  @70
	; -------------------------------
	; Save the adress of LoadLibrary
	; -------------------------------
_a:	mov @LoadLib, eax
; --------------------------------
; Save the address of FreeLibrary
; --------------------------------
	lea  ecx, @FreeLibraryStr
	pop  eax
	push ecx
	push eax
	call esi
	or   eax, eax
	jne  _b

	push 30h
	push offset capt
	push offset msg2
	push 0
	call MessageBox
	jmp  @70

_b:	mov  @FreeLibrary, eax
; --------------------------------
; Write the address of MessageBox
; --------------------------------
	mov  eax, MessageBox
	mov  eax, [eax+2]
	mov  eax, [eax]
	mov  @MessageBox, eax	
; ---------------------------------
; Write the address of ExitProcess
; ---------------------------------
	mov  eax, ExitProcess
	mov  eax, [eax+2]
	mov  eax, [eax]
	mov  @ExitProcess, eax
; --------------------------
; Alloc space to structures
; --------------------------
	mov eax, sizeof STARTUPINFO + sizeof PROCESS_INFORMATION + 16
	push eax
	push 0
	call GlobalAlloc
        mov  esi, eax
; ------------------------------------
; Map the dll to save some data in it
; ------------------------------------
	lea eax, @DLLName
	invoke CreateFile, eax, GENERIC_READ or GENERIC_WRITE, 0, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	cmp eax, -1
        je @6
	push eax
	invoke CreateFileMapping, eax, 0, PAGE_READWRITE, 0, 0, 0
	pop  ecx
	push eax
	push ecx
	call CloseHandle
	pop  eax
	push eax
	invoke MapViewOfFile, eax, FILE_MAP_ALL_ACCESS, 0, 0, 0
	test eax, eax
	jne  @7

	call CloseHandle
	jmp  @6

@7:     mov  pFile, eax
        call CloseHandle
; ----------------------------------
; Get entry point of remote process
; ----------------------------------
	; ------------------------------------------------
	; Open and map the file with the program to patch
	; ------------------------------------------------
	lea  eax, @FileName
	invoke CreateFile, eax, GENERIC_READ or GENERIC_WRITE, 0, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	cmp eax, -1
        jne  _op
@no:	push pFile
	call UnmapViewOfFile
	jmp  @6

_op:	push eax
	invoke CreateFileMapping, eax, 0, PAGE_READWRITE, 0, 0, 0
	pop  ecx
	push eax
	push ecx
	call CloseHandle
	pop  eax
	push eax
	invoke MapViewOfFile, eax, FILE_MAP_ALL_ACCESS, 0, 0, 0
	test eax, eax
	jne  @7_

	call CloseHandle
	jmp  @no

@7_:	mov  edi, eax
	add  eax, [eax+3Ch]
	; -------------------
	; Get the image base
	; -------------------
	mov  edx, [eax+4+14h+1Ch]
	; ---------------------------
	; Get the RVA of entry point
	; ---------------------------
	mov  eax, [eax+4+14h+10h]
	; -----------------------
	; Convert the RVA in VA
	; -----------------------
	add  eax, edx
	mov  @EntryPoint, eax
	; ------------------
	; Close the file
	; ------------------
	call CloseHandle
	push edi
	call UnmapViewOfFile
; ----------------------------------------
; Create the process and get data from it
; ----------------------------------------
@8:	push esi
	call GetStartupInfo

	mov  edi, esi
	add  edi, sizeof STARTUPINFO

	xor  ebx, ebx

	push edi
	push esi
	push ebx
	push ebx
	push CREATE_SUSPENDED	; <- look
	push ebx
	push ebx
	push ebx
	push offset @FileName
	push ebx
	call CreateProcess
	test eax, eax
	je   @6

	; -------------------------------------------------------------
	; Get the size of the data block that will be saved in the DLL
	; -------------------------------------------------------------
@4:	mov  SnpSize, (offset @3 - offset @0)
	; --------------------------------
	; Get a pointer to the image base
	; --------------------------------
	mov  ecx, pFile
	push ecx
	add  ecx, [ecx+3Ch]
	mov  edx, [ecx+4+14h+1Ch]
	; -------------------------------
	; Get a pointer to .data section
	; -------------------------------
	mov  eax, [ecx+4+14h+0E0h+50h+28h+14h]
	pop  ecx
	add  eax, ecx
	; ----------------------
	; Has the DLL the data?
	; ----------------------
	cmp  byte ptr [eax], 0
	jne  @ya
; -----------------------------------------------
; Set the data at begin of the DLL .data section
; -----------------------------------------------
	; ------------
	; Entry point
	; ------------
	push @EntryPoint
	pop  dword ptr [eax]
	; -------------------
	; Size of data block
	; -------------------
	push SnpSize
	pop  dword ptr [eax+4]
	; -----------
	; Image base
	; -----------
	push edx
	pop  dword ptr [eax+8]
  
	push eax

	push 12
	push eax
	call FlushViewOfFile
; ----------------------------------------------------
; Save the original data of target process in the dll
; ----------------------------------------------------
	; ----------------------------------------------
	; Get a pointer to a available space in the dll 
	; ----------------------------------------------
	pop  ecx
	add  ecx, 0Fh
	; -------------------------------------------------
	; Move the original data of the process to the dll 
	; -------------------------------------------------
	push offset temp_dword
	push SnpSize
	mov  ebx, ecx
	push ecx
	push @EntryPoint
	push dword ptr [edi]
	call ReadProcessMemory

	push SnpSize
	push ebx
	call FlushViewOfFile

@ya:	push pFile
	call UnmapViewOfFile
; -----------------------------------------------------------
; Write in the process the code that load and unload the DLL
; -----------------------------------------------------------
@5:	push offset old_value
	push 40h
	push SnpSize
	push @EntryPoint
	push dword ptr [edi]
	call VirtualProtectEx

	lea  edx, @temp
        mov  ebx, SnpSize
	push edx
	push ebx
	lea  esi, @0
	push esi
	push @EntryPoint
	push dword ptr [edi]
	call WriteProcessMemory
	
	push ebx
	push dword ptr [edi]
	call FlushInstructionCache

	push offset old_value
	mov  eax, old_value
	push eax
	push SnpSize
	push @EntryPoint
	push dword ptr [edi]
	call VirtualProtectEx
; ------------------------------------
; Resume the process and clos handles
; ------------------------------------
	push dword ptr [edi+4]
	call ResumeThread

	push dword ptr [edi+4]
        call CloseHandle

	push dword ptr [edi]
        call CloseHandle

@6:	push esi
	call GlobalFree
; -----------------
; Close the loader
; -----------------
@70:	push 0
	call ExitProcess

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; Data of the loader. You must link the .code section with write
; access ( /section: .code,W)

@kernel32 	db 'kernel32.dll', 0
@user32		db 'user32.dll', 0
@LoadLibrary 	db 'LoadLibraryA', 0
@FreeLibraryStr db 'FreeLibrary', 0
@FileName       db 'NOTEPAD.EXE', 0
msg1		db 'Error to intend get the address of LoadLibrary.', 0
msg2		db 'Error to intend get the address of FreeLibrary.', 0
msg3		db 'Error to intend read in the remote process.',0
capt		db 'ERROR!!!', 0
@krn32		dd 0
temp_dword	dd 0
@EntryPoint     dd 0
pFile		dd 0
@temp		dd 0
old_value	dd 0
SnpSize		dd 0

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; This is the code that will be writen in the remote process
; and will be executed when this process begins.

; When the DLL is unloaded, the original code will be
; restaured and the process will continue like if nothing
; has hapenned : - )


; ======================== PATCH ==========================

@0:   call @1
@1:   pop ebp
      sub ebp, offset @1
      jmp @2

; -------------------------- DATA ---------------------------

@DLLName	  db 'PATCHER.DLL', 0
@error		  db 'ERROR!', 0
@problem	  db 'Some problem, gulp (: - (', 0

; This data will be writen by the loader.

@LoadLib	  dd 0
@FreeLibrary	  dd 0
@MessageBox	  dd 0
@ExitProcess	  dd 0

; -------------------------- CODE ---------------------------

@2:
	push esi
	push edi

; Load the DLL
	mov  eax, [ebp+@LoadLib]
	lea  edx, [ebp+@DLLName]
	push edx
	call eax
	or   eax, eax
	je   @out

; Unload the DLL and restaure the original instructions	
	pop  esi
	pop  edi

	push eax
	mov  eax, [ebp+@FreeLibrary]
	call eax

; If the DLL has not been loaded, advise and exit
@out:
	xor  eax, eax
	push eax
	push eax
	lea  ecx, [ebp+@error]
	push ecx
	lea  edx, [ebp+@problem]
	push edx
	push eax
	call [ebp+MessageBox]
	call [ebp+ExitProcess]
@3:

; ------------------------ END OF CODE -----------------------

end start

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
